import java.sql.*;
import java.util.*;
import oracle.sql.*;
import oracle.jdbc.*;
import java.math.*;

public class ExempleUDTEnSQLData 
{
  public static void main (String args []) throws Exception {
    // Cration d'une Connection globale pour l'application
    UsineConnection uneUsineConnection = new UsineConnection();
    Connection uneConnection = uneUsineConnection.getConnectionSansAutoCommit(
            "oracle.jdbc.driver.OracleDriver",
            "jdbc:oracle:thin:@localhost:1521:orcl",
            "godin","oracle");
    try{
        // Recherche de la rfrence au LivreType ISBN = '0-201-12227-8'
        PreparedStatement unPreparedStatement = uneConnection.prepareStatement
        ("SELECT REF(l) AS refLivre FROM Livre l WHERE l.ISBN = '0-201-12227-8'");
        ResultSet unResultSet = unPreparedStatement.executeQuery();

        //Crer un type map qui associe le UDT  la classe SQLdata
        java.util.Map typeMap = uneConnection.getTypeMap();
        typeMap.put("LIVRETYPE",Class.forName("LivreTypePourUDT"));
        typeMap.put("TYPEDONNESANNE",Class.forName("Typedonnesanne"));
        typeMap.put("EDITEURTYPE",Class.forName("EditeurTypePourUDT"));
        
        if (unResultSet.next()){
          // Conversion de la rfrence  l'UDT LivreType sous forme d'un objet Java REF
          REF ref = (REF) unResultSet.getObject(1);

          LivreTypePourUDT unLivreType = (LivreTypePourUDT)ref.getValue();
          System.out.println("ISBN :"+unLivreType.getIsbn()); // ISBN CHAR(13)
          System.out.println("titre :"+unLivreType.getTitre()); // titre VARCHAR(50)
          Typedonnesanne unTypedonnesanne = unLivreType.getAnneparution(); // anneParution TypeDonnesAnne
          System.out.println("anne :"+unTypedonnesanne.getValeuranne()); // valeurAnne INTEGER

          REF unEditeurRef = (REF) unLivreType.getditeur();
          EditeurTypePourUDT unEditeurTypePourUDT = (EditeurTypePourUDT)unEditeurRef.getValue();

          System.out.println("nomEditeur :" + unEditeurTypePourUDT.getNomediteur()); // nomEditeur VARCHAR(20)
          System.out.println("ville :"+unEditeurTypePourUDT.getVille()); // ville VARCHAR(20)

          // Suivre les rfrences inverses
          // L'attribut lesLivres est une table enchsse extraite sous forme d'ARRAY
          ARRAY laTableEnchasse =  (ARRAY)unEditeurTypePourUDT.getLeslivres(); //lesLivres tableRefLivresType
                    
          // Extraire les lments sous forme de tableau d'objets
          Object[] lesLivres = (Object[])laTableEnchasse.getArray();

          // Parcours de la table enchsse
          for (int i=0; i<lesLivres.length;i++){
            // Chacun des lments de la table enchsse est un UDT LivreRefType converti en STRUCT
            STRUCT unREFLivreStruct = (STRUCT) lesLivres[i];
            Object attributsDeREFLivreStruct[] = unREFLivreStruct.getAttributes();
            REF refLivre = (REF)attributsDeREFLivreStruct[0]; // livreRef REF LivreType

            LivreTypePourUDT unAutreLivreType = (LivreTypePourUDT)refLivre.getValue();
            System.out.println("ISBN :"+unAutreLivreType.getIsbn()); // ISBN CHAR(13)
            System.out.println("titre :"+unAutreLivreType.getTitre()); // titre VARCHAR(50)
          }
        }else{
            throw new Exception("Livre inexistant");
        }
    }
    catch(Exception lException){
            lException.printStackTrace();
    }
    finally{
            uneConnection.commit();
            uneConnection.close();
            System.exit(0);
    }
  }
}